<?php

namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class HelloController extends AbstractController
{
    /**
     * @Route("/helloRandom")
     */
    public function randomNameAction() {
        return new Response("<html><body><h1>Hello "
            .self::generateRandomName()
            ."</h1></body></html>");
    }

    /**
     * @Route("/hello/{name}", defaults={"name" = ""})
     */
    public function nameAction($name, Request $request) {
        if ($name == "") {
            $sessionName = $request->getSession()->get('name');
            if ($sessionName) {
                $name = $sessionName;
            } else {
                $name = self::generateRandomName();
            }
        } else {
            $request->getSession()->set('name', $name);
        }

        return $this->render('hello/hello.html.twig', [ 'name' => $name ]);
    }

    static function generateRandomName()
    {
        $nouns = ['Circle', 'Cone', 'Cylinder', 'Ellipse', 'Hexagon',
          'Irregular Shape', 'Octagon', 'Oval', 'Parallelogram', 'Pentagon',
          'Pyramid', 'Rectangle', 'Semicircle', 'Sphere', 'Square', 'Star',
          'Trapezoid', 'Triangle', 'Wedge', 'Whorl'];
        $adjectives = ['Amusing', 'Athletic', 'Beautiful', 'Brave', 'Careless',
          'Clever', 'Crafty', 'Creative', 'Cute', 'Dependable', 'Energetic',
          'Famous', 'Friendly', 'Graceful', 'Helpful', 'Humble', 'Inconsiderate',
          'Likable', 'Middle Class', 'Outgoing', 'Poor', 'Practical', 'Rich',
          'Sad', 'Skinny', 'Successful', 'Thin', 'Ugly', 'Wealth'];
        return $adjectives[array_rand($adjectives)].' '.$nouns[array_rand($nouns)];
    }
}
