<?php
namespace App\Tests\Controller;

use App\Controller\HelloController;
use Symfony\Bundle\FrameworkBundle\Test\WebTestCase;

class HelloControllerTest extends WebTestCase
{
    public function testHelloRandomRoute()
    {
        $client = static::createClient();

        $crawler = $client->request('GET', '/helloRandom');

        $this->assertEquals(200, $client->getResponse()->getStatusCode());
        $this->assertContains('Hello ', $crawler->filter('h1')->text());
    }

    public function testHelloNamed()
    {
        $client = static::createClient();

        $crawler = $client->request('GET', '/hello/Allan');

        $this->assertEquals(200, $client->getResponse()->getStatusCode());
        $this->assertEquals('Hello Allan', $crawler->filter('h1')->text());
    }

    public function testHelloUnnamed()
    {
        $client = static::createClient();

        $crawler = $client->request('GET', '/hello');

        $this->assertEquals(200, $client->getResponse()->getStatusCode());
        $len = $crawler->filter('h1')->text();
        $this->assertGreaterThan(6, strlen($len));
    }

    public function testHelloNamedSession()
    {
        $client = static::createClient();

        $crawler = $client->request('GET', '/hello/Allan');

        $this->assertEquals(200, $client->getResponse()->getStatusCode());
        $this->assertEquals('Hello Allan', $crawler->filter('h1')->text());

        $this->assertEquals('Allan', $client->getRequest()->getSession()->get('name'));
    }

    public function testHelloUnnamedSession()
    {
        $client = static::createClient();

        $crawler = $client->request('GET', '/hello');

        $this->assertEquals(200, $client->getResponse()->getStatusCode());
        $len = $crawler->filter('h1')->text();
        $this->assertGreaterThan(6, strlen($len));

        $name = $client->getRequest()->getSession()->get('name');
        if ($name) {
        }
    }

    function testRandomNameGenerator(){
        $rdName = HelloController::generateRandomName();
        $this->assertGreaterThan(1, strlen($rdName));
    }

}
